/[gentoo-x86]/eclass/elisp.eclass
Gentoo

Contents of /eclass/elisp.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.37 - (hide annotations) (download)
Sat Feb 7 11:32:45 2009 UTC (5 years, 7 months ago) by fauli
Branch: MAIN
Changes since 1.36: +3 -3 lines
remove die messages

1 ulm 1.29 # Copyright 1999-2008 Gentoo Foundation
2 mkennedy 1.1 # Distributed under the terms of the GNU General Public License v2
3 fauli 1.37 # $Header: /var/cvsroot/gentoo-x86/eclass/elisp.eclass,v 1.36 2008/11/16 10:23:42 ulm Exp $
4 vapier 1.4 #
5 ulm 1.20 # Copyright 2002-2003 Matthew Kennedy <mkennedy@gentoo.org>
6 ulm 1.29 # Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
7 opfer 1.32 # Copyright 2007-2008 Christian Faulhammer <opfer@gentoo.org>
8 ulm 1.29 # Copyright 2007-2008 Ulrich Müller <ulm@gentoo.org>
9 vapier 1.4 #
10 ulm 1.21 # @ECLASS: elisp.eclass
11     # @MAINTAINER:
12 ulm 1.24 # Feel free to contact the Emacs team through <emacs@gentoo.org> if you
13     # have problems, suggestions or questions.
14 ulm 1.21 # @BLURB: Eclass for Emacs Lisp packages
15     # @DESCRIPTION:
16     #
17     # This eclass sets the site-lisp directory for Emacs-related packages.
18 opfer 1.17 #
19 opfer 1.18 # Emacs support for other than pure elisp packages is handled by
20 ulm 1.20 # elisp-common.eclass where you won't have a dependency on Emacs itself.
21     # All elisp-* functions are documented there.
22 ulm 1.30 #
23     # If the package's source is a single (in whatever way) compressed elisp
24     # file with the file name ${P}.el, then this eclass will move ${P}.el to
25     # ${PN}.el in src_unpack().
26 ulm 1.23
27 ulm 1.35 # @ECLASS-VARIABLE: SITEFILE
28     # @DESCRIPTION:
29     # Name of package's site-init file. The filename must match the shell
30     # pattern "[1-8][0-9]*-gentoo.el"; numbers below 10 and above 89 are
31     # reserved for internal use. "50${PN}-gentoo.el" is a reasonable choice
32     # in most cases.
33    
34 ulm 1.23 # @ECLASS-VARIABLE: DOCS
35     # @DESCRIPTION:
36 opfer 1.19 # DOCS="blah.txt ChangeLog" is automatically used to install the given
37     # files by dodoc in src_install().
38 ulm 1.23
39     # @ECLASS-VARIABLE: NEED_EMACS
40     # @DESCRIPTION:
41 opfer 1.19 # If you need anything different from Emacs 21, use the NEED_EMACS
42     # variable before inheriting elisp.eclass. Set it to the major version
43     # your package uses and the dependency will be adjusted.
44    
45     inherit elisp-common versionator
46    
47 ulm 1.33 DEPEND=">=virtual/emacs-${NEED_EMACS:-21}"
48     RDEPEND=">=virtual/emacs-${NEED_EMACS:-21}"
49 opfer 1.19 IUSE=""
50 opfer 1.18
51 opfer 1.19 elisp_pkg_setup() {
52 ulm 1.33 local need_emacs=${NEED_EMACS:-21}
53     local have_emacs=$(elisp-emacs-version)
54     if ! version_is_at_least "${need_emacs}" "${have_emacs}"; then
55     eerror "This package needs at least Emacs ${need_emacs}."
56 opfer 1.19 eerror "Use \"eselect emacs\" to select the active version."
57 ulm 1.33 die "Emacs version ${have_emacs} is too low."
58 opfer 1.19 fi
59 ulm 1.36 einfo "Emacs version: ${have_emacs}"
60 opfer 1.19 }
61 mkennedy 1.1
62 opfer 1.18 elisp_src_unpack() {
63 ulm 1.33 [ -n "${A}" ] && unpack ${A}
64 ulm 1.30 if [ -f ${P}.el ]; then
65 fauli 1.37 mv ${P}.el ${PN}.el || die
66 opfer 1.18 fi
67 mkennedy 1.5 }
68    
69 opfer 1.18 elisp_src_compile() {
70 ulm 1.35 elisp-compile *.el || die
71 mkennedy 1.5 }
72    
73 opfer 1.18 elisp_src_install() {
74 ulm 1.35 elisp-install ${PN} *.el *.elc || die
75     if [ -n "${SITEFILE}" ]; then
76     elisp-site-file-install "${FILESDIR}/${SITEFILE}" || die
77     fi
78 opfer 1.19 if [ -n "${DOCS}" ]; then
79 fauli 1.37 dodoc ${DOCS} || die
80 opfer 1.19 fi
81 mkennedy 1.5 }
82    
83 opfer 1.18 elisp_pkg_postinst() {
84     elisp-site-regen
85 mkennedy 1.5 }
86    
87 opfer 1.18 elisp_pkg_postrm() {
88     elisp-site-regen
89 mkennedy 1.5 }
90 mkennedy 1.9
91 ulm 1.29 EXPORT_FUNCTIONS \
92     src_unpack src_compile src_install \
93     pkg_setup pkg_postinst pkg_postrm

  ViewVC Help
Powered by ViewVC 1.1.20